Status: Closed   

Priority: Normal   

Assignee: Brian Witt   

Category: BMC   
Pull request: https://github.com/theforeman/foreman/p

ull/1608

  

Description

We have a setup with several smart proxies.  Sometimes when loading a host page and clicking on the 'BMC' tab, we'll see

Failure: ERF12-1772 [ProxyAPI::ProxyException]: Unable to perform power BMC operation ([RestClient::BadRequest]: 400 Bad

Request) for proxy <wrong smart proxy>

Somehow it's picking the wrong smart proxy, even though all the settings are correct. (subnet for the bmc interface is correct, ip

address, mac is correct)

AND it seems to work 4/5 of the time, only picking the wrong one 1 out of 5.

Associated revisions

Revision 57a32e98 - 07/23/2014 04:39 AM - Daniel Lobato Garcia

Fixes #6518 - look up the BMC proxy via any subnet proxies, if present

Revision fe102b16 - 06/01/2015 03:54 AM - Aaron Stone

Refs #6518 - Use #find instead of #select #first to choose a BMC proxy for the subnet

Enumerable#find more idiomatic in Ruby, and since it stops at the first match it

may be marginally faster.

History

#1 - 07/07/2014 06:48 PM - Brian Witt

I've submitted PR 1569

https://github.com/theforeman/foreman/pull/1569

#2 - 07/08/2014 03:10 AM - Dominic Cleal

- Category set to BMC

- Status changed from New to Ready For Testing

- Assignee set to Brian Witt

- Target version set to 1.8.0

#3 - 07/08/2014 12:22 PM - Brian Witt

I forgot to mention, that in those lines in app/models/nic/bmc.rb:28-29

SmartProxy.with_features("BMC").joins(:subnets).where(['dhcp_id = ? or tftp_id = ?', subnet_id, subnet_id]).first if subnet_id

proxy ||= SmartProxy.with_features("BMC").first

seems to always fail (i.e. it always picks the 'first' one), even when foreman picks the right proxy (or at least I see the status appear on the bmc tab). 

So I'm not sure what's going on there.

#4 - 07/08/2014 12:30 PM - Brian Witt

The 'first' one is not reachable by foreman normally, so when it fails I see a connection error to that first smart proxy.  The other times when it works I
https://github.com/theforeman/foreman/pull/1569


presume it's actually talking to the right smart proxy, even though the 'proxy' var in the code is set to the 'first' (unreachable) one.

#5 - 07/22/2014 12:15 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/1608 added

#6 - 07/23/2014 04:38 AM - Dominic Cleal

- translation missing: en.field_release set to 10

#7 - 07/23/2014 05:01 AM - Daniel Lobato Garcia

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 57a32e9828bd7cb1900024cc87c7386fd5582aca.
